/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2023,Shanghai Maritime University
 * All rights reserved.
 *
 * @file       		getadc.c
 * @author     		li
 * @version    		0.9
 * @Software 		  MDK FOR C251 V5.60
 * @Target        STC32G12K128
 * @date       		2023-6-14
*  @brief         ADCɼ
 ********************************************************************************************************************/
#include "headfile.h"

uint8  ADC[8]={0};
uint8  BATTERY[5]={0};
uint8  battery_low_flag = 0;
uint8  battery_low_count = 0;
uint16 sum_Lhorizontal_outside = 0;
uint16 sum_Lhorizontal_inside = 0;
uint16 sum_Lvertical = 0;
uint16 sum_Ldiagonal= 0;
uint16 sum_Lright= 0;
uint16 sum_Lleft= 0;
uint16 diff_Lhorizontal_outside = 0;
uint16 diff_Lhorizontal_inside = 0;
uint16 diff_Lvertical = 0;
uint16 diff_Ldiagonal= 0;

//-------------------------------------------------------------------
//  @brief      adcʼ
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------
void getADC_init(void)
{
    adc_init(ADC_P10, ADC_SYSclk_DIV_2);	
    adc_init(ADC_P11, ADC_SYSclk_DIV_2);	
    adc_init(ADC_P13, ADC_SYSclk_DIV_2);
    adc_init(ADC_P14, ADC_SYSclk_DIV_2);	
    adc_init(ADC_P15, ADC_SYSclk_DIV_2);
    adc_init(ADC_P16, ADC_SYSclk_DIV_2);
    adc_init(ADC_P17, ADC_SYSclk_DIV_2);
    adc_init(ADC_P06, ADC_SYSclk_DIV_2);
    adc_init(ADC_P05, ADC_SYSclk_DIV_2);  //ز
}

//-------------------------------------------------------------------
//  @brief      adc5ξֵ˲
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------
void getADC(void)
{
    ADC[0] = (uint8)adc_mean_filter_convert(ADC_P06,5);  //
		ADC[1] = (uint8)adc_mean_filter_convert(ADC_P13,5);  //б
		ADC[2] = (uint8)adc_mean_filter_convert(ADC_P17,5);  //
		ADC[3] = (uint8)adc_mean_filter_convert(ADC_P16,5);  //к
		ADC[4] = (uint8)adc_mean_filter_convert(ADC_P15,5);  //к
		ADC[5] = (uint8)adc_mean_filter_convert(ADC_P14,5);  //
		ADC[6] = (uint8)adc_mean_filter_convert(ADC_P11,5);  //б
		ADC[7] = (uint8)adc_mean_filter_convert(ADC_P10,5);  //Һ
    
    Normalization();
    
    sum_Lhorizontal_outside   = ADC_normalized[0]+ADC_normalized[7];
    sum_Lhorizontal_inside    = ADC_normalized[3]+ADC_normalized[4];
    sum_Lvertical             = ADC_normalized[2]+ADC_normalized[5];
    sum_Ldiagonal             = ADC_normalized[1]+ADC_normalized[6];
    sum_Lleft                 = ADC_normalized[0]+ADC_normalized[1];
    sum_Lright                = ADC_normalized[6]+ADC_normalized[7];
    diff_Lhorizontal_outside  = abs(ADC_normalized[0]-ADC_normalized[7]);
    diff_Lhorizontal_inside   = abs(ADC_normalized[3]-ADC_normalized[4]);
    diff_Lvertical            = abs(ADC_normalized[2]-ADC_normalized[5]);
    diff_Ldiagonal            = abs(ADC_normalized[1]-ADC_normalized[6]);
}

//-------------------------------------------------------------------
//  @brief      adcֵ˲
//  @param      ch     adcͨ  
//  @param      count  ˲
//  @return     sum    ˲ֵ    
//-------------------------------------------------------------------
uint16 adc_mean_filter_convert (ADCN_enum ch, const uint8 count)
{
    uint8 i;
    uint16 sum;

    sum = 0;
    for(i=0; i<count; i++)
    {
        sum += adc_once(ch, ADC_8BIT);	
    }

    sum = sum/count;
    return sum;
}

//-------------------------------------------------------------------
//  @brief      صѹ
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------
void batteryCheck() 
{
    if(battery_low_flag !=1)
    {
      if(adc_once(ADC_P05, ADC_8BIT)<BATTERY_LOW_THRESHOLD)
        battery_low_count++;
    }
    if(battery_low_count > 10)
      battery_low_flag =1;
}