/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2023,Shanghai Maritime University
 * All rights reserved.
 *
 * @file       		key.c
 * @author     		li
 * @version    		0.9
 * @Software 		  MDK FOR C251 V5.60
 * @Target        STC32G12K128
 * @date       		2023-5-21
 ********************************************************************************************************************/
#include "headfile.h"

uint8 key_value = 0;
uint8 key_downFlag = 0;
uint8 start_standbyflag = 0;
uint8 start_keyflag = 0; 

void keyInit(void)
{
  gpio_mode(P4_4, GPI_IMPEDANCE);
  gpio_mode(P7_3, GPI_IMPEDANCE);
  gpio_mode(P3_7, GPI_IMPEDANCE);
  gpio_mode(P3_6, GPI_IMPEDANCE);
  gpio_mode(P7_0, GPI_IMPEDANCE);
  gpio_mode(P7_1, GPI_IMPEDANCE);
  gpio_mode(P7_2, GPI_IMPEDANCE);
  gpio_mode(P3_3, GPI_IMPEDANCE);
}

void keyDetect(void)
{
   if(BTN1==0 ||BTN2==0 || BTN3==0 || BTN4==0)
    keyScan();
}

void keyScan(void)
{
    if(BTN1==0)
    {
      delay_ms(20);
      if(BTN1==0)
      {
        //key_value =1;
        //key_downFlag = 1;
        if(start_standbyflag == 0)
          start_standbyflag = 1;
      }
    }
    if(BTN2==0)
    {
      delay_ms(20);
      if(BTN2==0)
        key_value =2;
        key_downFlag = 1;
    }
    if(BTN3==0)
    {
      delay_ms(20);
      if(BTN3==0)
        key_value =3;
        key_downFlag = 1;
    }
    if(BTN4==0)
    {
      delay_ms(20);
      if(BTN4==0)
      {
        if(start_keyflag == 0)
          start_keyflag = 1;
      }
    }
}