/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2023,Shanghai Maritime University
 * All rights reserved.
 *
 * @file       		motor.c
 * @author     		li
 * @version    		0.9
 * @Software 		  MDK FOR C251 V5.60
 * @Target        STC32G12K128
 * @date       		2023-5-21
 ********************************************************************************************************************/
#include "headfile.h"

int32 PWM_L=0;
int32 PWM_R=0;
//-------------------------------------------------------------------------------------------------------------------
//  @brief      ioʼ
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------------------------------------------------------
void Motor_init(void)
{
  pwm_init(PWMA_CH2P_P62, 100000, 0);  
  pwm_init(PWMA_CH1P_P60, 100000, 0);  
  pwm_init(PWMA_CH3P_P64, 100000, 0);  
  pwm_init(PWMA_CH4P_P66, 100000, 0);  
  pwm_init(PWMB_CH1_P74,  100, 0);   //left
  pwm_init(PWMB_CH2_P75,  100, 0);   //right 
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      PWM
//  @param      speed_L,speed_R    ҵռձ
//  @return     void   
//-------------------------------------------------------------------------------------------------------------------
void Motor_run(int32 speed_L,int32 speed_R)
{
	  if(speed_L>=0)
    {
      speed_L=labs(speed_L);
      speed_L= speed_L>PWM_DUTY_MAX?PWM_DUTY_MAX:speed_L;
			pwm_duty(PWMA_CH3P_P64, speed_L);
      pwm_duty(PWMA_CH4P_P66, 0);
    }		
    else
    {
      speed_L=labs(speed_L);
      speed_L= speed_L>PWM_DUTY_MAX?PWM_DUTY_MAX:speed_L;
      pwm_duty(PWMA_CH4P_P66, speed_L);
      pwm_duty(PWMA_CH3P_P64, 0);
    }
    if(speed_R>=0)
    {
      speed_R=labs(speed_R);
      speed_R= speed_R>PWM_DUTY_MAX?PWM_DUTY_MAX:speed_R;
			pwm_duty(PWMA_CH2P_P62, speed_R);
      pwm_duty(PWMA_CH1P_P60, 0);
    }		
    else
    {
      speed_R=labs(speed_R);
      speed_R= speed_R>PWM_DUTY_MAX?PWM_DUTY_MAX:speed_R;
      pwm_duty(PWMA_CH1P_P60, speed_R);
      pwm_duty(PWMA_CH2P_P62, 0);
    }
}

void BLDC_start(void)
{
  pwm_duty(PWMB_CH1_P74, 1100);
  pwm_duty(PWMB_CH2_P75, 1100);  //10%speed
}

void BLDC_run(int32 pwm)
{
  uint32 BLDC_pwmL = 0;
  uint32 BLDC_pwmR = 0;

  pwm = constrain_float(pwm, -10000, 10000);
  if(emergency_stop_flag || out_of_border_flag)
  {
    BLDC_stop();
  }
	else if(elements == RAMP)
	{
		pwm_duty(PWMB_CH2_P75, 1300);    
    pwm_duty(PWMB_CH1_P74, 1300); 
	}
  else if(pwm > 0)
  {
    BLDC_pwmL =(labs(pwm)*(1600-1100))/10000+1200;  
    pwm_duty(PWMB_CH2_P75, BLDC_pwmL);    
    pwm_duty(PWMB_CH1_P74, 1200); 
  }
  else 
  {
    BLDC_pwmR =(labs(pwm)*(1600-1100))/10000+1200;  
    pwm_duty(PWMB_CH1_P74, BLDC_pwmR);    
    pwm_duty(PWMB_CH2_P75, 1200); 
  }
	
}

void BLDC_stop(void)
{
  pwm_duty(PWMB_CH1_P74, 0);
  pwm_duty(PWMB_CH2_P75, 0);  //break
}