/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2023,Shanghai Maritime University
 * All rights reserved.
 *
 * @file       		normalization.c
 * @author     		li
 * @version    		0.9
 * @Software 		  MDK FOR C251 V5.60
 * @Target        STC32G12K128
 * @date       		2023-5-21
 ********************************************************************************************************************/
#include "headfile.h"

uint8 ADC_max[8]={245,144,76,157,169,77,165,245};
//uint8 ADC_min[8]={0,0,0,0,0,0,0,0};
uint16 ADC_normalized[8]={0,0,0,0,0,0,0,0};
uint8 exit_normalization = 0;


//-------------------------------------------------------------------
//  @brief      һmax/minԶɼ
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------
void Normalization_get(void)
{
   uint8 i;
   
   ips114_clear(WHITE);
   ips114_showstr(0,0,"inductor normalization 1-8 -->");
   ips114_showstr(0,1,"MAX");
   ips114_showstr(0,3,"MIN");

   while(exit_normalization ==1)
  {   
    ADC[0] = (uint8)adc_mean_filter_convert(ADC_P06,5);  //
		ADC[1] = (uint8)adc_mean_filter_convert(ADC_P13,5);  //б
		ADC[2] = (uint8)adc_mean_filter_convert(ADC_P17,5);  //
		ADC[3] = (uint8)adc_mean_filter_convert(ADC_P16,5);  //к
		ADC[4] = (uint8)adc_mean_filter_convert(ADC_P15,5);  //к
		ADC[5] = (uint8)adc_mean_filter_convert(ADC_P14,5);  //
		ADC[6] = (uint8)adc_mean_filter_convert(ADC_P11,5);  //б
		ADC[7] = (uint8)adc_mean_filter_convert(ADC_P10,5);  //Һ
    
    for(i = 0; i <8; i++)
    {
      if(ADC[i]>ADC_max[i])
        ADC_max[i]=ADC[i];

    }
    ips114_showuint8(0,  2, ADC_max[0]);
    ips114_showuint8(30, 2, ADC_max[1]);
    ips114_showuint8(60, 2, ADC_max[2]);
    ips114_showuint8(90, 2, ADC_max[3]);
    ips114_showuint8(120,2, ADC_max[4]);
    ips114_showuint8(150,2, ADC_max[5]);
    ips114_showuint8(180,2, ADC_max[6]);
    ips114_showuint8(210,2, ADC_max[7]);
/*
    ips114_showuint8(0,  4, ADC_min[0]);
    ips114_showuint8(30, 4, ADC_min[1]);
    ips114_showuint8(60, 4, ADC_min[2]);
    ips114_showuint8(90, 4, ADC_min[3]);
    ips114_showuint8(120,4, ADC_min[4]);
    ips114_showuint8(150,4, ADC_min[5]);
    ips114_showuint8(180,4, ADC_min[6]);
    ips114_showuint8(210,4, ADC_min[7]);
*/
    exit_normalization = P70;

    }   
    if(!exit_normalization)
    {
      ips114_showstr(0,5,"Storing data...");
      iap_erase_page(D_DS_ADC_MAX);
      iap_write_bytes(D_DS_ADC_MAX, ADC_max, 8);
      //iap_write_bytes(D_DS_ADC_MIN, ADC_min, 8);
      delay_ms(200);
      ips114_clear(WHITE);



    }
}

//-------------------------------------------------------------------
//  @brief      һ
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------
void Normalization(void)
{
  uint8 i;
  for(i=0; i<8; i++)
    ADC_normalized[i]=(100*ADC[i])/(ADC_max[i]);
    
}

//-------------------------------------------------------------------
//  @brief      һȡ洢ֵ
//  @param      void    
//  @return     void    
//-------------------------------------------------------------------
void Normalization_read_stored_data(void)
{
  iap_read_bytes(D_DS_ADC_MAX, ADC_max, 8);
  //iap_read_bytes(D_DS_ADC_MIN, ADC_min, 8);
}

