/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2023,Shanghai Maritime University
 * All rights reserved.
 *
 * @file       		task.c
 * @author     		li
 * @version    		0.9
 * @Software 		  MDK FOR C251 V5.60
 * @Target        STC32G12K128
 * @date       		2023-6-24
*  @brief         ļ
 ********************************************************************************************************************/
#include "headfile.h"

int32 err_Lhorizontal_outside = 0;
int32 err_Lhorizontal_inside = 0;
int32 err_Ldiagonal = 0;
int32 dir_err = 0;
int32 all_dir_err = 0;
int32 angle_err = 0;
int32 out_err = 0;
int8  Esign = 0;
uint8 finish_flag = 0;
uint8 barrier_count = 0;
uint8 roundabout_count = 0;

Elements_enum elements = NORMAL;
int8  roundabout_flag  = 0;  
uint8 roundabout_dir   = ROUNDABOUT_DIR; //0-right 1-left
uint8 roundabout_type  = ROUNDABOUT_TYPE; //0- 1-С
int8  barrier_flag     = 0; 
uint8 barrier_dir      = BARRIER_DIR; //0-right 1-left
int8  garage_flag      = 0;
uint8 garage_dir       = GARAGE_DIR; //0-left 1-right
int8  exit_garage_flag = EXIT_GARAGE_FLAG ;    
uint8 exit_garage_dir  = GARAGE_DIR; //0-right 1-left
int8  crossing_flag    = 0;
uint8 crossing_count   = 0;
int8  ramp_flag = 0;
int8  protect_flag = 0;

Count tof_count = {2,2}; //53
//----------------------------------------------------------------------------------
//  @brief      ȡerr
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void get_err(void)
{
  err_Lhorizontal_outside = (FACTOR_LHORIZONTAL_OUTSIDE*((int8)ADC_normalized[0]-(int8)ADC_normalized[7]))/((int8)ADC_normalized[0]+(int8)ADC_normalized[7]);
  err_Ldiagonal= (FACTOR_LDIAGONAL*((int8)ADC_normalized[1]-(int8)ADC_normalized[6]))/((int8)ADC_normalized[1]+(int8)ADC_normalized[6]);
  all_dir_err = err_Lhorizontal_outside + err_Ldiagonal;
  if(out_of_border_flag || emergency_stop_flag || elements == BARRIER || elements == GARAGE || exit_garage_flag >= 0)
    out_err = 0;
  else
  {
   if(labs(all_dir_err) < 20 && elements == NORMAL)  //ֶpid-1
    {
      PIDparam_DIR.kp          = DIR_kp;
      PIDparam_DIR.kp2nd       = DIR_kp2nd;  
      PIDparam_DIR.ki          = DIR_ki;
      PIDparam_DIR.kd          = DIR_kd;
      PIDparam_DIR.kd2nd       = DIR_kd2nd;

      PIDparam_ANGLE.kp        = ANGLE_kp;
      PIDparam_ANGLE.kp2nd     = ANGLE_kp2nd;  
      PIDparam_ANGLE.ki        = ANGLE_ki;
      PIDparam_ANGLE.kd        = ANGLE_kd;
      PIDparam_ANGLE.kd2nd     = ANGLE_kd2nd;
			
			//SpeedL_set = 70;
			//SpeedR_set = 70;
    }
		else if(elements == ROUNDABOUT || elements == RAMP)
		{
      PIDparam_DIR.kp          = DIR_kp_3s ;
      PIDparam_DIR.kp2nd       = DIR_kp2nd_3s;  
      PIDparam_DIR.ki          = DIR_ki_3s;
      PIDparam_DIR.kd          = DIR_kd_3s;
      PIDparam_DIR.kd2nd       = DIR_kd2nd_3s;			
		}
    else                       //ֶpid-2
    {
      PIDparam_DIR.kp          = DIR_kp_2s ;
      PIDparam_DIR.kp2nd       = DIR_kp2nd_2s;  
      PIDparam_DIR.ki          = DIR_ki_2s;
      PIDparam_DIR.kd          = DIR_kd_2s;
      PIDparam_DIR.kd2nd       = DIR_kd2nd_2s;

      PIDparam_ANGLE.kp        = ANGLE_kp_2s;
      PIDparam_ANGLE.kp2nd     = ANGLE_kp2nd_2s;  
      PIDparam_ANGLE.ki        = ANGLE_ki_2s;
      PIDparam_ANGLE.kd        = ANGLE_kd_2s;
      PIDparam_ANGLE.kd2nd     = ANGLE_kd2nd_2s;
			
			//SpeedL_set = 30;
			//SpeedR_set = 30;
    }
		
    dir_err   = PidLocCtrl(&PIDparam_DIR, 0, all_dir_err);
    angle_err = -PidLocCtrl(&PIDparam_ANGLE, 0, gyro_z);
    out_err   = dir_err + angle_err;
		 
  }
}

//----------------------------------------------------------------------------------
//  @brief      Ԫش
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void elements_handler(void)
{
  if(exit_garage_flag >= 0)
    exit_garage();
  else
  { 
    if(elements == NORMAL)
      //find_crossing();
    if(elements == NORMAL)
      find_roundabout();
    if(elements == NORMAL)
      //find_barrier();
    if(elements == NORMAL)
      find_garage();
   /* if(elements == NORMAL)
      find_ramp();
		*/
    switch(elements)
    { 
      case NORMAL:
      
      break;
/*---------*/
      case PROTECTION:
      	if(protect_flag == 0)
					protect_flag = 1;
			  protect_handler();
			break;
/*-----µ----*/   
      case RAMP:
				if(ramp_flag == 0)
					ramp_flag = 1;
			  ramp_handler();
      break;
/*-----Բ----*/           
      case ROUNDABOUT:
        if(roundabout_flag == 0)
				{
					roundabout_flag = 1;
					if(roundabout_count == 1)
					{
					 	roundabout_dir = 1;  //0-right 1-left
						roundabout_type = 1;
					}
          else if(roundabout_count == 2)
					{
						roundabout_dir = 1;
						roundabout_type = 1;
					}
					else if(roundabout_count == 3)
					{
						roundabout_dir = 1;
						roundabout_type = 1;
					}
				}
        roundabout_handler();
      break;
/*-----·----*/    
      case BARRIER:
        if(barrier_flag == 0 && (barrier_count == 2 || barrier_count == 1  ) )
				{
					barrier_flag = 1;
					{
						if(barrier_count == 1)
						barrier_dir = 1;
						else
						barrier_dir = 1;
					}						
				}
				else if(barrier_flag == 0 && (barrier_count == 3))
					elements = RAMP;
					else if(barrier_flag == 0 && (barrier_count == 4))
					elements = PROTECTION;
				barrier_handler();
				break;
/*-----ʮ----*/    
     
      case CROSSING:
        if(crossing_flag == 0)
        crossing_flag = 1;
      crossing_handler();
      break;
/*---------*/       
      case GARAGE:
        if(garage_flag == 0)
          garage_flag = 1;
        garage_handler();
      break;
      default: break;
    }
  }
 }
//----------------------------------------------------------------------------------
//  @brief      task
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
 void protect_handler(void)
 {
	 if(protect_flag == 1)
	 {
		 distance = 0;
		 protect_flag =2;
	 }
	 else if(protect_flag == 2)
	 {
	 if (distance > PROTECTION_DISTANCE)
	 protect_flag = 3;	 
	 }
	 else if(protect_flag == 3)
	 {
	  protect_flag = 0;
		elements = NORMAL;
	 }
 }
//----------------------------------------------------------------------------------
//  @brief      RAMP task
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
/*
 void find_ramp(void)
{
	if(ramp_flag == 0 && gyro_y_i > 15 && elements == NORMAL)
	elements = RAMP;     
  else
  elements = NORMAL;
}	*/
void ramp_handler(void)
{
	if (ramp_flag == 1)
		{
		//pwm_duty(PWMB_CH1_P74, 1800);
    //pwm_duty(PWMB_CH2_P75, 1800); 
		distance = 0;
			ramp_flag = 2;
		}
		else if (ramp_flag == 2)
		{
			if(gyro_y_i < -5)
			{
				ramp_flag = 3;
				//distance = 0;
			}
		}
		else if (ramp_flag == 3)
		{
			if(distance > 100)
			//if(gyro_y_i < 2 && gyro_y_i > -2)
			{
				gyro_y_i = 0;
				ramp_flag = 0;
				elements = PROTECTION;
			}
	}	

}
//----------------------------------------------------------------------------------
//  @brief      Ѱ·
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------

void find_barrier(void)
{
  //if((barrier_flag >= 0 && dl1a_distance_mm <850 && dl1a_distance_mm > 700 && elements == NORMAL)||barrier_flag > 0)
  //if(counters(&tof_count, ((barrier_flag >= 0 && dl1a_distance_mm <1000 && dl1a_distance_mm > 800 && elements == NORMAL && gyro_z < BARRIER_ANGLESPEED_FILTER && distance_all > BARRIER_DISTANCE_FILTER)||barrier_flag > 0)))
 if(counters(&tof_count, ((barrier_flag >= 0 && dl1a_distance_mm <1200 &&dl1a_distance_mm > 300 && elements == NORMAL && fabs(gyro_z_i_3) < BARRIER_ANGLESPEED_FILTER && distance_all > BARRIER_DISTANCE_FILTER)||barrier_flag > 0)))
{
    if(barrier_flag == 0)
    {barrier_count ++;
    //if(barrier_count == 1 || 2)
      elements = BARRIER;
  }
}
  else 
     elements = NORMAL;
}
/*
void find_barrier(void)
{
  //if((barrier_flag >= 0 && dl1a_distance_mm <850 && dl1a_distance_mm > 700 && elements == NORMAL)||barrier_flag > 0)
  if(counters(&tof_count, ((barrier_flag >= 0 && dl1a_distance_mm <1000 && dl1a_distance_mm > 800 && elements == NORMAL && gyro_z < BARRIER_ANGLESPEED_FILTER)||barrier_flag > 0)))
    elements = BARRIER;
  else 
     elements = NORMAL;
}
*/
//----------------------------------------------------------------------------------
//  @brief      ·task
//  @param      void

//  @return     void   
//----------------------------------------------------------------------------------
void barrier_handler(void)
{
  if(emergency_stop_flag)
  {
      SpeedL_set = 0;
      SpeedR_set = 0;
  }
  else if(barrier_flag == 1)
  {
    out_err = 0;  //л򿪻
    SpeedL_set = 0;
    SpeedR_set = 0; //speed down
    gyro_z_i = 0; //Ƕ
    barrier_flag = 2;
  }
  else if(barrier_flag == 2)
  {
    if(barrier_dir == 0) //right
    {
      out_err = 0;  //л򿪻
      SpeedL_set = 23;//23
      SpeedR_set = 10;
      if(gyro_z_i < -45)  //ȥ 40
       { 
        barrier_flag = 3;
        distance = 0;
       }  
    }
    else              //left
    {
      out_err = 0;  //л򿪻
      SpeedL_set = 10;
      SpeedR_set = 23;
      if(gyro_z_i > 45)  //ȥ
        {  
        barrier_flag = 3;
        distance = 0;
        }  
    }
  }

  else if(barrier_flag == 3)
 {
    SpeedL_set = 20;
    SpeedR_set = 20;
    if(distance > 65) //250-60 300-40
    {
     gyro_z_i = 0;
     barrier_flag = 4;
    }
 }

  else if(barrier_flag == 4) //
  {
    if(barrier_dir == 0) //right
    {
      out_err = 0; 
      SpeedL_set = 15;
      SpeedR_set = 30;
      if(gyro_z_i > 65)  //׼ֱ
       barrier_flag = 5;
    }
    else              //left
    {
      out_err = 0;  
      SpeedL_set = 30;
      SpeedR_set = 15;
      if(gyro_z_i < -65)  //׼ֱ
        barrier_flag = 5;
    }
  }
  else if(barrier_flag == 5) //׼ֱ
  {
    SpeedL_set = 40;
    SpeedR_set = 40;
    if(sum_Lhorizontal_inside > 10)
     barrier_flag = 6;
  }
  else if(barrier_flag == 6) //
  {
    elements = PROTECTION;
    SpeedL_set = SPEEDL_SET;
    SpeedR_set = SPEEDR_SET;
    barrier_flag = 0;
  }
}

//----------------------------------------------------------------------------------
//  @brief      Ѱʮ
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void find_crossing(void)
{
  if((sum_Lvertical > 200 && sum_Lhorizontal_inside < 200 && crossing_flag >= 0 && gyro_z >= -50&& gyro_z <= 50)||crossing_flag > 0)
		/* && gyro_z >= -50&& gyro_z <= 50*/
    elements = CROSSING; 
  else
    elements = NORMAL;
}

//----------------------------------------------------------------------------------
//  @brief      ʮtask
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void crossing_handler(void)
{
	
  if(crossing_flag == 1)
  {
    distance = 0;
    //ADC_normalized[1]=10;
    //ADC_normalized[6]=10;
    crossing_flag = 2;
  }
	
   if(crossing_flag == 2)
  {
		//ADC_normalized[0]=100;
		//ADC_normalized[7]=100;
    ADC_normalized[1]=0;
    ADC_normalized[6]=0;
    if(distance > CROSSING_DISTANCE)
      crossing_flag = 3;
  }
  else if(crossing_flag == 3)
  {
    crossing_count ++;
    if(crossing_count == 3)
      crossing_flag = -1;
    else 
      crossing_flag = 0;
    elements = NORMAL;
  }
}

//----------------------------------------------------------------------------------
//  @brief      ѰԲ
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void find_roundabout(void)
{
  if(   (roundabout_flag >=0
    && ((sum_Lleft > 90 && sum_Lright > 55 && diff_Ldiagonal < 20 && sum_Lhorizontal_inside > 150) //
    ||  (sum_Lleft > 55 && sum_Lright > 90 && diff_Ldiagonal < 20 && sum_Lhorizontal_inside > 150)))
    ||   roundabout_flag > 0)
	 { 
      elements = ROUNDABOUT;
	    roundabout_count ++;
		/*if (sum_Lleft > sum_Lright)
		  roundabout_dir = 1;
	 else
		  roundabout_dir = 0;
		*/
	  }  
    else
       elements = NORMAL;
}

//----------------------------------------------------------------------------------
//  @brief      Բtask
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void roundabout_handler(void)
{
    if(roundabout_flag == 1)
    {
      distance = 0;
      roundabout_flag = 2;
      
      SpeedL_set = 50;
      SpeedR_set = 50;

    }
    else if(roundabout_flag == 2) //Բ
    {
      if(roundabout_type == 1) //С
      {
        if(roundabout_dir == 1)//
        {
          //ADC_normalized[0]=ADC_normalized[0];
          //ADC_normalized[1]=ADC_normalized[1];
        }
        else
        {
          //ADC_normalized[7]=ADC_normalized[7];
          //ADC_normalized[6]=ADC_normalized[6];
        }
      }
      else //
      {
        if(roundabout_dir == 1)//
        {
         //ADC_normalized[0]=ADC_normalized[0];
         // ADC_normalized[1]=ADC_normalized[1];
        }
        else
        {
          //ADC_normalized[7]=ADC_normalized[7];
          //ADC_normalized[6]=ADC_normalized[6];
        }
      }
      //if(sum_Lhorizontal_inside > 240) speed=200
			 if(sum_Lhorizontal_inside > ROUNDABOUT_CENTERPOINT)//280-out0
      {
        gyro_z_i = 0;
        roundabout_flag = 3;
      }
      if(distance > ROUNDABOUT_DISTANCE_FILTER)
      {
        roundabout_flag = 0;
        elements = NORMAL;
      }
    }
    else if(roundabout_flag == 3)  //е
    {
      if(roundabout_type == 1) //С
      {
        if(roundabout_dir == 1)//
        {
          ADC_normalized[7]=ADC_normalized[7]*0.09;   
          ADC_normalized[6]=ADC_normalized[6]*0.09;
          if(gyro_z_i > ROUNDABOUT_STAGE3GYRO_S_L)
            roundabout_flag = 4;
        }
        else
        {
          ADC_normalized[0]=ADC_normalized[0]*0.09;
          ADC_normalized[1]=ADC_normalized[1]*0.09;
          if(gyro_z_i <-ROUNDABOUT_STAGE3GYRO_S_R)
            roundabout_flag = 4;
        }
      }
      else //
      {
        if(roundabout_dir == 1)//
        {	
          ADC_normalized[7]=ADC_normalized[7]*0.09;
          ADC_normalized[6]=ADC_normalized[6]*0.09;
          if(gyro_z_i >ROUNDABOUT_STAGE3GYRO_B)
            roundabout_flag = 4;
        }
        else
        {
          ADC_normalized[0]=ADC_normalized[0]*0.3;
          ADC_normalized[1]=ADC_normalized[1]*0.3;
          if(gyro_z_i <-ROUNDABOUT_STAGE3GYRO_B)
            roundabout_flag = 4;
        }
      }
     }
    else if(roundabout_flag == 4) //
    {   
      if(roundabout_type == 1) //С
      {
        if(roundabout_dir == 1)//
        {
          if(gyro_z_i > ROUNDABOUT_STAGE4GYRO_S_L) 
					{	
            roundabout_flag = 5;
					  distance = 0;
					}
        }
        else
        {
        if(gyro_z_i < -ROUNDABOUT_STAGE4GYRO_S_R)
         {
						roundabout_flag = 5;
					  distance = 0;
					}
        }
      }
      else //
      {
        if(roundabout_dir == 1)//
        {
          if(gyro_z_i > ROUNDABOUT_STAGE4GYRO_B_L)
					{
						roundabout_flag = 5;
					  distance = 0;
				  }
        }
        else
        {
          if(gyro_z_i < -ROUNDABOUT_STAGE4GYRO_B_R)
          {
						roundabout_flag = 5;
					  distance = 0;
					}
        }
      }
    }
    else if(roundabout_flag == 5) //1
    {
      if(roundabout_type == 1) //С
      {
        if(roundabout_dir == 1)//
        {
          ADC_normalized[6]=ADC_normalized[6]*0.31;   // speed=250
          ADC_normalized[7]=ADC_normalized[7]*0.31; 
          if(distance > ROUNDABOUT_STAGE5DISTANCE_S_L) //
          {
            distance = 0;
            roundabout_flag = 6;
          }
        }
        else
        {
          ADC_normalized[1]=ADC_normalized[1]*0.6;
          ADC_normalized[0]=ADC_normalized[0]*0.6;
         if(distance > ROUNDABOUT_STAGE5DISTANCE_S_R)
          {
            distance = 0;
            roundabout_flag = 6;
          }
        }
      }
      else //
      {
        if(roundabout_dir == 1)//
        {
          ADC_normalized[6]=ADC_normalized[6]*0.31;
          ADC_normalized[7]=ADC_normalized[7]*0.31;
         if(distance > ROUNDABOUT_STAGE5DISTANCE_B_L)
          {  
            distance = 0;
            roundabout_flag = 6;
          }
        }
        else
        {
          ADC_normalized[0]=ADC_normalized[0]*0.6;
          ADC_normalized[1]=ADC_normalized[1]*0.6;
          if(distance > ROUNDABOUT_STAGE5DISTANCE_B_R)//
          {  
            distance = 0;
            roundabout_flag = 6;
          }
        }
      }
    }
		 else if(roundabout_flag == 6)//2OUT
		{
      if(roundabout_type == 1) //С
      {
        if(roundabout_dir == 1)//
        {
          ADC_normalized[1]=ADC_normalized[1]*0.23; // speed=250
          ADC_normalized[0]=ADC_normalized[0]*0.23; 
         if(distance > ROUNDABOUT_STAGE6DISTANCE_S)   //
          {
            distance = 0;
            roundabout_flag = -1;
          }
        }
        else
        {
          ADC_normalized[6]=ADC_normalized[6]*0.30;
          ADC_normalized[7]=ADC_normalized[7]*0.30;
         if(distance > ROUNDABOUT_STAGE6DISTANCE_S)
          {
            distance = 0;
            roundabout_flag = -1;
          }
        }
      }
      else //
      {
        if(roundabout_dir == 1)//
        {
          ADC_normalized[1]=ADC_normalized[1]*0.23;
          ADC_normalized[0]=ADC_normalized[0]*0.23;
          if(distance > ROUNDABOUT_STAGE6DISTANCE_B)
          {  
            distance = 0;
            roundabout_flag = -1;
          }
        }
        else
        {
          ADC_normalized[6]=ADC_normalized[6]*0.3;
          ADC_normalized[7]=ADC_normalized[7]*0.3;
          if(distance > ROUNDABOUT_STAGE6DISTANCE_B)
          {  
            distance = 0;
            roundabout_flag = -1;
          }
        }
      }

    }		 
    else if(roundabout_flag == -1) //
    {
			SpeedL_set = 70;
			SpeedR_set = 70;
			roundabout_flag = ROUNDABOUT_MUTIRECO;
			elements = PROTECTION;         
    }
}

//----------------------------------------------------------------------------------
//  @brief      Ѱҳ
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void find_garage(void)
{
  if(!P53 || garage_flag > 0)
    elements = GARAGE;
}

//----------------------------------------------------------------------------------
//  @brief      task
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void garage_handler(void)
{
  if(garage_flag == 1)
  {
    out_err = 0;  //л򿪻
    SpeedL_set = 0;
    SpeedR_set = 0; //speed down
    gyro_z_i = 0; //Ƕ
    distance = 0;
    garage_flag = 2;
  }
  else if(garage_flag ==2)
  {
    if(garage_dir == 0) 
    { 
      SpeedL_set = -80;
      SpeedR_set = -80;     
      if(distance < -30)//speed=250,distance=-10
      {
        garage_flag = 3;
        distance = 0;
        gyro_z_i = 0;
      }
    }
    else   //
    {
      SpeedL_set = -80;
      SpeedR_set = -80;     
      if(distance < -25)
      {
        garage_flag = 3;
        distance = 0;
        gyro_z_i = 0;
      }
    }
  }
  else if(garage_flag == 3)
  {
       if(garage_dir == 0)  //
      {
        SpeedL_set = -5;
        SpeedR_set = -10;
        out_err = 0;  //л򿪻
        //emergency_stop_flag = 1;
        if(gyro_z_i < -65)
        {
          garage_flag = 4;
          distance = 0;
        }
      }
      else 
      {
        SpeedL_set = -10;
        SpeedR_set = -5;
        out_err = 0;  //л򿪻
        //emergency_stop_flag = 1;
        if(gyro_z_i > 65)
        {
          garage_flag = 4;
          distance = 0;
        }
      }
  }
   else if(garage_flag == 4)
  {
       // if(distance > 60)
        SpeedR_set = -100;
        SpeedL_set = -100;
        if(distance < -40)//fast-28
          garage_flag = 5;
        //emergency_stop_flag = 1; 
        //finish_flag = 1;
  }
  else if(garage_flag == 5)
 {
        emergency_stop_flag = 1; 
        finish_flag = 1;
 }
}

//----------------------------------------------------------------------------------
//  @brief      task
//  @param      void
//  @return     void   
//----------------------------------------------------------------------------------
void exit_garage(void)
{
  if(exit_garage_flag == 0)
  {
    distance = 0;
    gyro_z_i = 0;
    exit_garage_flag = 1;
  }
  else if(exit_garage_flag == 1)
  {
     SpeedL_set = 16;
     SpeedR_set = 16; 

    if(distance > 5)
     exit_garage_flag = 2;
   }
   else if(exit_garage_flag == 2)
   {
   if(exit_garage_dir == 0 && exit_garage_flag == 2) //
    {
      out_err = 0;  //л򿪻
      SpeedL_set = 15;
      SpeedR_set = 19; //=20
      if(gyro_z_i > 85)
        exit_garage_flag = 3;
    }
    
    else   //ҳ
    {
      out_err = 0;  //л򿪻
      SpeedL_set = 19;
      SpeedR_set = 15; 
      if(gyro_z_i <-85 )
        exit_garage_flag = 3;    
    }
    }
  
  else if(exit_garage_flag == 3)
  {
    //Esign = 0;
    elements = NORMAL;
    SpeedL_set = SPEEDL_SET;  //лջ
    SpeedR_set = SPEEDR_SET;
    exit_garage_flag = -1;
  }
}

