/***********************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2023,Shanghai Maritime University
 * All rights reserved.
 *
 * @file       		main.c
 * @author     		li
 * @version    		0.9
 * @Software 		  MDK FOR C251 V5.60
 * @Target        STC32G12K128
 * @date       		2023-6-14
 *******************************************************************************/

#include "headfile.h"

/*
 * ϵͳƵʣɲ鿴board.hе FOSC 궨޸ġ
 * board.hļFOSCֵΪ0,ԶϵͳƵΪ33.1776MHZ
 * board_init,ѾP54Ϊλ
 * ҪʹP54,board.cļеboard_init()ɾSET_P54_RESRT
 */

uint8 scope_char[50];
int16 SpeedL_set = SPEEDL_SET;
int16 SpeedR_set = SPEEDR_SET;
uint8 trig_times=0;
uint8 out_of_border_testcount=0;
uint8 out_of_border_flag=0;
uint8 stopflag = 1;
uint8 wireless_uart_receive = 0;
uint8 remote_start_trig_times=0;
uint8 emergency_stop_flag=0;
uint8 tof_pit_counter = 0;
uint8 gyro_pit_counter = 0;

void main()
{
  DisableGlobalIRQ();		//رж
	board_init();			// ʼĴ,ɾ˾롣
  Motor_init();
  dl1a_init();
  imu660ra_init();
  imu660ra_getOffset();
  iap_init();			//ʼEEPROM
  ctimer_count_init(CTIM0_P34);
  ctimer_count_init(CTIM1_P35);
  wireless_uart_init();
  getADC_init();
  ips114_init();
  ips114_clear(WHITE);
  PidInit(&PIDparam_LMOTOR,V_kp_L, V_kp2nd_L, V_ki_L, V_kd_L, V_kd2nd_L, V_imax_L, V_outmax);
  PidInit(&PIDparam_RMOTOR,V_kp_R, V_kp2nd_R, V_ki_R, V_kd_R, V_kd2nd_R, V_imax_R, V_outmax);
  PidInit(&PIDparam_DIR,DIR_kp, DIR_kp2nd, DIR_ki, DIR_kd, DIR_kd2nd, DIR_imax, DIR_outmax);
  PidInit(&PIDparam_ANGLE,ANGLE_kp, ANGLE_kp2nd, ANGLE_ki, ANGLE_kd, ANGLE_kd2nd, ANGLE_imax, ANGLE_outmax);
  pit_timer_ms(TIM_4, 2);//ٶȻ
  keyInit();
  gpio_mode(P5_3,GPI_IMPEDANCE); //hall sensor
	gpio_mode(P0_4,GPO_PP); //hall sensor
  //Normalization_read_stored_data();
  EnableGlobalIRQ();		//ж
  delay_ms(500);    
    while(1)
	{
  
    #if VIRTURAL_SCOPE
    sprintf(scope_char,",speedl=%d,speedr=%d",SpeedL_get,SpeedR_get);
    wireless_uart_send_buff(scope_char, sizeof(scope_char)-1);
    #endif
    
    #if HMI_MENU
    keyDetect();
    exit_normalization = P70;
    if(exit_normalization)
      Normalization_get();
    #endif

  #if BATTERY_PROTECTION
   if(battery_low_flag ==1)
   {
     ips114_clear(YELLOW);
     ips114_showstr(50,4,"--BATTERY LOW--");
     DisableGlobalIRQ();		//رж
     Motor_run(0,0);
     BLDC_stop(); 
     while(1);
    }
   #endif

   #if BORDER_PROTECTION
    if(ADC[0]+ADC[1]+ADC[2]+ADC[3]+ADC[4]+ADC[5]+ADC[6]+ADC[7] < 50)
    {  
      trig_times++;
      if(trig_times <= 1)
      {
        out_of_border_testcount++;
        if(out_of_border_testcount >= 1 && barrier_flag <1 && exit_garage_flag == -1 && garage_flag < 1)
				//if(out_of_border_testcount >= 1 && barrier_flag <1 && garage_flag < 1)
        {
          SpeedL_set = 0;
          SpeedR_set = 0;
          out_of_border_flag=1;
          ips114_clear(YELLOW);
          ips114_showstr(160,0,"OUT OF BORDER");
          ips114_showstr(0,1,"BC");
          ips114_showint8(160,1,barrier_count);
          ips114_showstr(0,2,"barrier_flag");
          ips114_showint8(160,2,barrier_flag);
          ips114_showstr(0,3,"garage_flag");
          ips114_showint8(160,3,garage_flag);
          ips114_showstr(0,4,"crossing_flag");
          ips114_showint8(160,4,crossing_flag);
          ips114_showstr(0,5,"exit_garage_flag");
          ips114_showint8(160,5,exit_garage_flag);
          ips114_showstr(0,6,"crossing_count");
          ips114_showint8(160,6,crossing_count);
          ips114_showstr(0,7,"gyro_z_i");
          ips114_showint8(160,7,gyro_z_i);
          ips114_showstr(0,8,"barrier_count");
          ips114_showint8(160,8,barrier_count);
          switch (elements)
          {
            case NORMAL:
              ips114_showstr(0,0,"normal");      
            break;
            case RAMP:
              ips114_showstr(0,0,"ramp");   
            break;
            case BARRIER:
              ips114_showstr(0,0,"barrier");   
            break;
            case CROSSING:
              ips114_showstr(0,0,"crossing");   
            break;
            case ROUNDABOUT:
              ips114_showstr(0,0,"roundabout");   
            break;
            case GARAGE:
              ips114_showstr(0,0,"garage");   
            break;
						case PROTECTION:
							ips114_showstr(0,0,"protection");   
						break;
            default: 
              ips114_showstr(0,0,"NAN");        
            break;
        }
          while(1);    
        }
      }
      else
      {
        trig_times = 0;
        out_of_border_testcount = 0;
      }
    }
   #endif
  
  #if EMERGENCY_STOP
   
   wireless_uart_read_buff (&wireless_uart_receive, 1);
   if(wireless_uart_receive == 0x00 && stopflag == 0 )
   {
      SpeedL_set = 0;
      SpeedR_set = 0;
      emergency_stop_flag = 1;
      ips114_clear(YELLOW);
      ips114_showstr(160,0,"EMERGENCY STOP");
      ips114_showstr(0,1,"roundabout_flag");
      ips114_showint8(160,1,roundabout_flag);
      ips114_showstr(0,2,"barrier_count");
      ips114_showint8(160,2,barrier_count);
      ips114_showstr(0,3,"garage_flag");
      ips114_showint8(160,3,garage_flag);
      ips114_showstr(0,4,"crossing_flag");
      ips114_showint8(160,4,crossing_flag);
      ips114_showstr(0,5,"exit_garage_flag");
      ips114_showint8(160,5,exit_garage_flag);
      ips114_showstr(0,6,"crossing_count");
      ips114_showint8(160,6,crossing_count);
      ips114_showstr(0,7,"gyro_z_i");
      ips114_showfloat(160,7,gyro_z_i,4,2);
     switch (elements)
      {
        case NORMAL:
          ips114_showstr(0,0,"normal");      
        break;
        case RAMP:
          ips114_showstr(0,0,"ramp");   
        break;
        case BARRIER:
          ips114_showstr(0,0,"barrier");   
        break;
        case CROSSING:
          ips114_showstr(0,0,"crossing");   
        break;
        case ROUNDABOUT:
          ips114_showstr(0,0,"roundabout");   
        break;
        case GARAGE:
          ips114_showstr(0,0,"garage");   
        break;
				case PROTECTION:
          ips114_showstr(0,0,"protection");   
        break;
        default: 
          ips114_showstr(0,0,"NAN");        
        break;
      }
      while(1);    
   }   

   else if(wireless_uart_receive == 0xff && stopflag == 1 && start_standbyflag == 2 ) //յź
   {
        remote_start_trig_times++;
        if(remote_start_trig_times > 3)
        {
          remote_start_trig_times = 0;
          delay_ms(2000);
          #if BLDC
          BLDC_start();
          delay_ms(2000);
          #endif 
          stopflag = 0; //ֹͣ ӳ500ms
        }
   }
  
   //else if(wireless_uart_receive == 0xff && stopflag == 0)
    //stopflag = 0;
  //else
    //stopflag = 1;
    //ips114_showuint8(0  ,5,wireless_uart_receive);
    //ips114_showuint8(30 ,1,stopflag);
  #endif
	
  #if KEYSTART
   if(start_keyflag == 1)
        {
          delay_ms(2000);
          #if BLDC
          BLDC_start();
          delay_ms(2000);
          #endif 
          stopflag = 0; //ֹͣ ӳ500ms
          start_keyflag = 2;
        }
  #endif
    #if IPS_DISPLAY
    if(start_standbyflag == 1)
    {
      ips114_clear(GREEN);
      ips114_showstr(50,4,"--STBY--");
      start_standbyflag = 2;
    } 
    else if(start_standbyflag == 0)
    {
      ips114_showstr(0,0,"inductor 1-8 -->");
      ips114_showuint8(0  ,1,ADC[0]);
      ips114_showuint8(30 ,1,ADC[1]);
      ips114_showuint8(60 ,1,ADC[2]);
      ips114_showuint8(90 ,1,ADC[3]);
      ips114_showuint8(120,1,ADC[4]);
      ips114_showuint8(150,1,ADC[5]);
      ips114_showuint8(180,1,ADC[6]);
      ips114_showuint8(210,1,ADC[7]);


      //ips114_showstr(0,2,"encoder L<-->R");
      //ips114_showint16(0,3, SpeedL_get);
      //ips114_showint16(60,3,SpeedR_get);
      ips114_showstr(0,2,"B");
      ips114_showint8(10,2,barrier_flag);
      ips114_showstr(60,2,"R");
      ips114_showuint8(70,2,roundabout_flag);
      ips114_showstr(120,2,"RP");
      ips114_showuint8(130,2,ramp_flag);
      ips114_showstr(180,2,"Bc");
      ips114_showuint8(190,2,barrier_count);
      ips114_showstr(0,3,"Zi2");
      ips114_showfloat(20,3,gyro_z_i_2,6,2);
      ips114_showstr(80,3,"Zi3");
      ips114_showfloat(100,3,gyro_z_i_3,4,2);
      ips114_showstr(160,3,"Zi");
      ips114_showfloat(180,3,gyro_z_i,4,2);
      ips114_showuint16(120,4,dl1a_distance_mm);
      //ips114_showint16(180,3,P53);
    //ips114_showint16(120,3,gyro_z);
    //ips114_showstr(0,2,"dir_err");
    //ips114_showint16(0,3,dir_err);
      switch (elements)
      {
        case NORMAL:
          ips114_showstr(0,4,"normal    ");      
        break;
        case RAMP:
          ips114_showstr(0,4,"ramp      ");   
        break;
        case BARRIER:
          ips114_showstr(0,4,"barrier   ");   
        break;
        case CROSSING:
          ips114_showstr(0,4,"crossing  ");   
        break;
        case ROUNDABOUT:
          ips114_showstr(0,4,"roundabout");   
        break;
        case GARAGE:
          ips114_showstr(0,4,"garage    ");   
        break;
				case PROTECTION:
          ips114_showstr(0,4,"protection");   
        break;
        default: 
          ips114_showstr(0,4,"NAN       ");        
        break;
      }
      ips114_showuint8( 60  ,4,roundabout_dir );
      //ips114_showstr(0,4,"normalized inductor 1-8 -->"); 
      ips114_showuint8(0  ,5,ADC_normalized[0]);
      ips114_showuint8(30 ,5,ADC_normalized[1]);
      ips114_showuint8(60 ,5,ADC_normalized[2]);
      ips114_showuint8(90 ,5,ADC_normalized[3]);
      ips114_showuint8(120,5,ADC_normalized[4]);
      ips114_showuint8(150,5,ADC_normalized[5]);
      ips114_showuint8(180,5,ADC_normalized[6]);
      ips114_showuint8(210,5,ADC_normalized[7]);

      ips114_showstr(0,6,"ERR--outside--out--diagonal->");
      ips114_showint32(0,7,all_dir_err,4);
      ips114_showint32(60,7,err_Lhorizontal_outside,4);
      ips114_showint32(120,7,out_err,4);
      ips114_showint32(180,7,err_Ldiagonal,4);
			

    }   
   #endif  
//P04 = !P04;
 } 

}